﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using Excel = Microsoft.Office.Interop.Excel;

namespace ExcelCharts
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("630C953B-0736-4F09-A245-5A5089499710"), ProgId("ExcelCharts.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private ADXRibbonTab adxRibbonTab1;
        private ADXRibbonGroup adxRibbonGroup1;
        private ADXRibbonButton insertChartRibbonButton;
        private ADXRibbonGroup adxRibbonGroup2;
        private ADXRibbonButton changeStyleRibbonButton;
        private ADXRibbonButton changeChartColorRibbonButton;
        private ImageList imlIcons;
        private ADXRibbonGroup adxRibbonGroup3;
        private ADXRibbonDropDown styleNumberRibbonDropDown1;
        private ADXRibbonItem adxRibbonItem1;
        private ADXRibbonItem adxRibbonItem2;
        private ADXRibbonItem adxRibbonItem3;
        private ADXRibbonItem adxRibbonItem4;
        private ADXRibbonItem adxRibbonItem5;
        private ADXRibbonItem adxRibbonItem6;
        private ADXRibbonItem adxRibbonItem7;
        private ADXRibbonItem adxRibbonItem8;
        private ADXRibbonItem adxRibbonItem9;
        private ADXRibbonItem adxRibbonItem10;
        private ADXRibbonDropDown colorNumberRibbonDropDown;
        private ADXRibbonItem adxRibbonItem11;
        private ADXRibbonItem adxRibbonItem12;
        private ADXRibbonItem adxRibbonItem13;
        private ADXRibbonItem adxRibbonItem14;
        private ADXRibbonItem adxRibbonItem15;
        private ADXRibbonItem adxRibbonItem16;
        private ADXRibbonItem adxRibbonItem17;
        private ADXRibbonItem adxRibbonItem18;
        private ADXRibbonItem adxRibbonItem19;
        private ADXRibbonItem adxRibbonItem20;
        private ADXRibbonItem adxRibbonItem21;
        private ADXRibbonItem adxRibbonItem22;
        private ADXRibbonItem adxRibbonItem23;
        private ADXRibbonItem adxRibbonItem24;
        private ADXRibbonItem adxRibbonItem25;
        private ADXRibbonItem adxRibbonItem26;
        private ADXRibbonItem adxRibbonItem27;
        private ADXRibbonDropDown chartTypeRibbonDropDown;
        private ADXRibbonButton changeChartTypeRibbonButton;
        private ADXRibbonItem adxRibbonItem28;
        private ADXRibbonItem adxRibbonItem29;
        private ADXRibbonItem adxRibbonItem30;
        private ADXRibbonItem adxRibbonItem31;
        private ADXRibbonItem adxRibbonItem32;
        private ADXRibbonSplitButton applyFilter;
        private ADXRibbonMenu adxRibbonMenu1;
        private ADXRibbonButton filterPavlovaRibbonButton;
        private ADXRibbonButton filterChaiRibbonButton;
        private ADXRibbonButton filterTofuRibbonButton;
        private ADXRibbonButton filterKonbuRibbonButton;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AddinModule));
            this.adxRibbonTab1 = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup1 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.insertChartRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.imlIcons = new System.Windows.Forms.ImageList(this.components);
            this.adxRibbonGroup2 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.styleNumberRibbonDropDown1 = new AddinExpress.MSO.ADXRibbonDropDown(this.components);
            this.adxRibbonItem1 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem2 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem3 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem4 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem5 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem6 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem7 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem8 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem9 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem10 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.colorNumberRibbonDropDown = new AddinExpress.MSO.ADXRibbonDropDown(this.components);
            this.adxRibbonItem11 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem12 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem13 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem14 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem15 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem16 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem17 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem18 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem19 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem20 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem21 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem22 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem23 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem24 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem25 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem26 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem27 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.chartTypeRibbonDropDown = new AddinExpress.MSO.ADXRibbonDropDown(this.components);
            this.adxRibbonItem28 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem29 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem30 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem31 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.adxRibbonItem32 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.changeStyleRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.changeChartColorRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.changeChartTypeRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxRibbonGroup3 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.applyFilter = new AddinExpress.MSO.ADXRibbonSplitButton(this.components);
            this.adxRibbonMenu1 = new AddinExpress.MSO.ADXRibbonMenu(this.components);
            this.filterPavlovaRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.filterChaiRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.filterTofuRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.filterKonbuRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            // 
            // adxRibbonTab1
            // 
            this.adxRibbonTab1.Caption = "Excel Charts";
            this.adxRibbonTab1.Controls.Add(this.adxRibbonGroup1);
            this.adxRibbonTab1.Controls.Add(this.adxRibbonGroup2);
            this.adxRibbonTab1.Controls.Add(this.adxRibbonGroup3);
            this.adxRibbonTab1.Id = "adxRibbonTab_19f00a5491314f319f7b9183a6390ce1";
            this.adxRibbonTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // adxRibbonGroup1
            // 
            this.adxRibbonGroup1.Caption = "Insert";
            this.adxRibbonGroup1.Controls.Add(this.insertChartRibbonButton);
            this.adxRibbonGroup1.Id = "adxRibbonGroup_db227466d2a541d49b60cf6bac2e91a5";
            this.adxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // insertChartRibbonButton
            // 
            this.insertChartRibbonButton.Caption = "Chart";
            this.insertChartRibbonButton.Id = "adxRibbonButton_f6b83e30ff4749298cd7bf2f197c877a";
            this.insertChartRibbonButton.Image = 0;
            this.insertChartRibbonButton.ImageList = this.imlIcons;
            this.insertChartRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.insertChartRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.insertChartRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.insertChartRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.insertChartRibbonButton_OnClick);
            // 
            // imlIcons
            // 
            this.imlIcons.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imlIcons.ImageStream")));
            this.imlIcons.TransparentColor = System.Drawing.Color.Transparent;
            this.imlIcons.Images.SetKeyName(0, "chart");
            this.imlIcons.Images.SetKeyName(1, "color");
            this.imlIcons.Images.SetKeyName(2, "filter");
            this.imlIcons.Images.SetKeyName(3, "style");
            this.imlIcons.Images.SetKeyName(4, "type");
            // 
            // adxRibbonGroup2
            // 
            this.adxRibbonGroup2.Caption = "Format";
            this.adxRibbonGroup2.Controls.Add(this.styleNumberRibbonDropDown1);
            this.adxRibbonGroup2.Controls.Add(this.colorNumberRibbonDropDown);
            this.adxRibbonGroup2.Controls.Add(this.chartTypeRibbonDropDown);
            this.adxRibbonGroup2.Controls.Add(this.changeStyleRibbonButton);
            this.adxRibbonGroup2.Controls.Add(this.changeChartColorRibbonButton);
            this.adxRibbonGroup2.Controls.Add(this.changeChartTypeRibbonButton);
            this.adxRibbonGroup2.Id = "adxRibbonGroup_ad99373d8e194acf9738ca9b2aff153e";
            this.adxRibbonGroup2.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup2.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // styleNumberRibbonDropDown1
            // 
            this.styleNumberRibbonDropDown1.Caption = "Style #";
            this.styleNumberRibbonDropDown1.Id = "adxRibbonDropDown_a0162a0cc7e94197ac3cf1dda69f8daa";
            this.styleNumberRibbonDropDown1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.styleNumberRibbonDropDown1.Items.Add(this.adxRibbonItem1);
            this.styleNumberRibbonDropDown1.Items.Add(this.adxRibbonItem2);
            this.styleNumberRibbonDropDown1.Items.Add(this.adxRibbonItem3);
            this.styleNumberRibbonDropDown1.Items.Add(this.adxRibbonItem4);
            this.styleNumberRibbonDropDown1.Items.Add(this.adxRibbonItem5);
            this.styleNumberRibbonDropDown1.Items.Add(this.adxRibbonItem6);
            this.styleNumberRibbonDropDown1.Items.Add(this.adxRibbonItem7);
            this.styleNumberRibbonDropDown1.Items.Add(this.adxRibbonItem8);
            this.styleNumberRibbonDropDown1.Items.Add(this.adxRibbonItem9);
            this.styleNumberRibbonDropDown1.Items.Add(this.adxRibbonItem10);
            this.styleNumberRibbonDropDown1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // adxRibbonItem1
            // 
            this.adxRibbonItem1.Caption = "1";
            this.adxRibbonItem1.Id = "adxRibbonItem_11dd3fef6d37432992af7d045836b233";
            this.adxRibbonItem1.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem2
            // 
            this.adxRibbonItem2.Caption = "2";
            this.adxRibbonItem2.Id = "adxRibbonItem_ee82f48bfd6c4f719da24b03355cb9c1";
            this.adxRibbonItem2.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem3
            // 
            this.adxRibbonItem3.Caption = "3";
            this.adxRibbonItem3.Id = "adxRibbonItem_7d24947e112145e583eb3cf2be314a2f";
            this.adxRibbonItem3.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem4
            // 
            this.adxRibbonItem4.Caption = "4";
            this.adxRibbonItem4.Id = "adxRibbonItem_836b69bedc964c76b1ff364a4ef464f5";
            this.adxRibbonItem4.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem5
            // 
            this.adxRibbonItem5.Caption = "5";
            this.adxRibbonItem5.Id = "adxRibbonItem_c4357917ec8d4746aeac3435217b75a6";
            this.adxRibbonItem5.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem6
            // 
            this.adxRibbonItem6.Caption = "6";
            this.adxRibbonItem6.Id = "adxRibbonItem_88f967fa1be04b91a6ff9bac359b5551";
            this.adxRibbonItem6.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem7
            // 
            this.adxRibbonItem7.Caption = "7";
            this.adxRibbonItem7.Id = "adxRibbonItem_8835b1e82ba04619af66a96e6cebfb6d";
            this.adxRibbonItem7.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem8
            // 
            this.adxRibbonItem8.Caption = "8";
            this.adxRibbonItem8.Id = "adxRibbonItem_99bcb039e52d4ec6a3498547e592ede5";
            this.adxRibbonItem8.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem9
            // 
            this.adxRibbonItem9.Caption = "9";
            this.adxRibbonItem9.Id = "adxRibbonItem_1889cab570d044d2b1f9711905bdf16e";
            this.adxRibbonItem9.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem10
            // 
            this.adxRibbonItem10.Caption = "10";
            this.adxRibbonItem10.Id = "adxRibbonItem_495be5ce65f14ede92a014a31c01f1b4";
            this.adxRibbonItem10.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // colorNumberRibbonDropDown
            // 
            this.colorNumberRibbonDropDown.Caption = "Color #";
            this.colorNumberRibbonDropDown.Id = "adxRibbonDropDown_067ea094d930412abc959dc9ac0e6de2";
            this.colorNumberRibbonDropDown.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem11);
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem12);
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem13);
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem14);
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem15);
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem16);
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem17);
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem18);
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem19);
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem20);
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem21);
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem22);
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem23);
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem24);
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem25);
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem26);
            this.colorNumberRibbonDropDown.Items.Add(this.adxRibbonItem27);
            this.colorNumberRibbonDropDown.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // adxRibbonItem11
            // 
            this.adxRibbonItem11.Caption = "1";
            this.adxRibbonItem11.Id = "adxRibbonItem_83795c83fe9a4b1d875b42c7dc8b6384";
            this.adxRibbonItem11.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem12
            // 
            this.adxRibbonItem12.Caption = "2";
            this.adxRibbonItem12.Id = "adxRibbonItem_3f2c9244d3d3475099cb1b3893865385";
            this.adxRibbonItem12.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem13
            // 
            this.adxRibbonItem13.Caption = "3";
            this.adxRibbonItem13.Id = "adxRibbonItem_7b2cf71352734f52a013189484a85f3a";
            this.adxRibbonItem13.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem14
            // 
            this.adxRibbonItem14.Caption = "4";
            this.adxRibbonItem14.Id = "adxRibbonItem_3e7361aa80bd488c80374d3575419337";
            this.adxRibbonItem14.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem15
            // 
            this.adxRibbonItem15.Caption = "5";
            this.adxRibbonItem15.Id = "adxRibbonItem_bb112795387b42a2b78da5a7e518f41a";
            this.adxRibbonItem15.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem16
            // 
            this.adxRibbonItem16.Caption = "6";
            this.adxRibbonItem16.Id = "adxRibbonItem_2572698af1e945f48dcc61b58cb35d58";
            this.adxRibbonItem16.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem17
            // 
            this.adxRibbonItem17.Caption = "7";
            this.adxRibbonItem17.Id = "adxRibbonItem_e2b4d1be23e245e9aeed43308b8d038c";
            this.adxRibbonItem17.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem18
            // 
            this.adxRibbonItem18.Caption = "8";
            this.adxRibbonItem18.Id = "adxRibbonItem_fcaef1d1e01f4c6fb070c6864ac2639a";
            this.adxRibbonItem18.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem19
            // 
            this.adxRibbonItem19.Caption = "9";
            this.adxRibbonItem19.Id = "adxRibbonItem_c18efe49d35c47418c06147e4df6dc5b";
            this.adxRibbonItem19.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem20
            // 
            this.adxRibbonItem20.Caption = "10";
            this.adxRibbonItem20.Id = "adxRibbonItem_b6c45546a55f4aaaa32d796fb9b08e12";
            this.adxRibbonItem20.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem21
            // 
            this.adxRibbonItem21.Caption = "13";
            this.adxRibbonItem21.Id = "adxRibbonItem_629c76aeae76498eae599e14fdc278f2";
            this.adxRibbonItem21.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem22
            // 
            this.adxRibbonItem22.Caption = "14";
            this.adxRibbonItem22.Id = "adxRibbonItem_7d28104ab70449f19bba294dd39863e4";
            this.adxRibbonItem22.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem23
            // 
            this.adxRibbonItem23.Caption = "16";
            this.adxRibbonItem23.Id = "adxRibbonItem_51c82fe846c4474984852aa528e8c6ca";
            this.adxRibbonItem23.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem24
            // 
            this.adxRibbonItem24.Caption = "18";
            this.adxRibbonItem24.Id = "adxRibbonItem_6dddaf2288da415abcf0d55832e309a5";
            this.adxRibbonItem24.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem25
            // 
            this.adxRibbonItem25.Caption = "20";
            this.adxRibbonItem25.Id = "adxRibbonItem_515210a16f7b457ba077aa334e59cb7a";
            this.adxRibbonItem25.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem26
            // 
            this.adxRibbonItem26.Caption = "22";
            this.adxRibbonItem26.Id = "adxRibbonItem_56a28dd7a761470399c8d207c0c5bfc3";
            this.adxRibbonItem26.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // adxRibbonItem27
            // 
            this.adxRibbonItem27.Caption = "24";
            this.adxRibbonItem27.Id = "adxRibbonItem_84ddec438b0c4221b052df225056510a";
            this.adxRibbonItem27.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // chartTypeRibbonDropDown
            // 
            this.chartTypeRibbonDropDown.Caption = "Type";
            this.chartTypeRibbonDropDown.Id = "adxRibbonDropDown_0de8f987251d4d1e863c9f5b15455be9";
            this.chartTypeRibbonDropDown.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.chartTypeRibbonDropDown.Items.Add(this.adxRibbonItem28);
            this.chartTypeRibbonDropDown.Items.Add(this.adxRibbonItem29);
            this.chartTypeRibbonDropDown.Items.Add(this.adxRibbonItem30);
            this.chartTypeRibbonDropDown.Items.Add(this.adxRibbonItem31);
            this.chartTypeRibbonDropDown.Items.Add(this.adxRibbonItem32);
            this.chartTypeRibbonDropDown.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // adxRibbonItem28
            // 
            this.adxRibbonItem28.Caption = "Line with Markers";
            this.adxRibbonItem28.Id = "adxRibbonItem_f1a744700da24c0985d037a983b30952";
            this.adxRibbonItem28.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonItem28.Tag = 65;
            // 
            // adxRibbonItem29
            // 
            this.adxRibbonItem29.Caption = "Pie of Pie";
            this.adxRibbonItem29.Id = "adxRibbonItem_df5c46ee7b4e4c049222a60c74c4139a";
            this.adxRibbonItem29.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonItem29.Tag = 68;
            // 
            // adxRibbonItem30
            // 
            this.adxRibbonItem30.Caption = "3D Clustered Bar";
            this.adxRibbonItem30.Id = "adxRibbonItem_19c64018140246e791035bfb9a505048";
            this.adxRibbonItem30.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonItem30.Tag = 60;
            // 
            // adxRibbonItem31
            // 
            this.adxRibbonItem31.Caption = "Clustered Cylinder Bar";
            this.adxRibbonItem31.Id = "adxRibbonItem_e35d5086f3d743ef9b4a430c696f7188";
            this.adxRibbonItem31.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonItem31.Tag = 95;
            // 
            // adxRibbonItem32
            // 
            this.adxRibbonItem32.Caption = "Clustered Column";
            this.adxRibbonItem32.Id = "adxRibbonItem_3a4a5f6b4e5f4575bb004ab68834fc83";
            this.adxRibbonItem32.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonItem32.Tag = 51;
            // 
            // changeStyleRibbonButton
            // 
            this.changeStyleRibbonButton.Caption = "Change Style";
            this.changeStyleRibbonButton.Id = "adxRibbonButton_3a0daf5184514a59ac505d6b4db82ba5";
            this.changeStyleRibbonButton.Image = 3;
            this.changeStyleRibbonButton.ImageList = this.imlIcons;
            this.changeStyleRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.changeStyleRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.changeStyleRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.changeStyleRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.changeStyleRibbonButton_OnClick);
            // 
            // changeChartColorRibbonButton
            // 
            this.changeChartColorRibbonButton.Caption = "Change Color";
            this.changeChartColorRibbonButton.Id = "adxRibbonButton_6858bd862db44169a16e489157c437b3";
            this.changeChartColorRibbonButton.Image = 1;
            this.changeChartColorRibbonButton.ImageList = this.imlIcons;
            this.changeChartColorRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.changeChartColorRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.changeChartColorRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.changeChartColorRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.changeChartColorRibbonButton_OnClick);
            // 
            // changeChartTypeRibbonButton
            // 
            this.changeChartTypeRibbonButton.Caption = "Change Type";
            this.changeChartTypeRibbonButton.Id = "adxRibbonButton_89034653ae204204a8a4cf991c301520";
            this.changeChartTypeRibbonButton.Image = 4;
            this.changeChartTypeRibbonButton.ImageList = this.imlIcons;
            this.changeChartTypeRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.changeChartTypeRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.changeChartTypeRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.changeChartTypeRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.changeChartTypeRibbonButton_OnClick);
            // 
            // adxRibbonGroup3
            // 
            this.adxRibbonGroup3.Caption = "Filter";
            this.adxRibbonGroup3.Controls.Add(this.applyFilter);
            this.adxRibbonGroup3.Id = "adxRibbonGroup_2494f60febc144bb9c777dba1326c1bb";
            this.adxRibbonGroup3.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup3.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // applyFilter
            // 
            this.applyFilter.Caption = "Filter By";
            this.applyFilter.Controls.Add(this.adxRibbonMenu1);
            this.applyFilter.Id = "adxRibbonSplitButton_02f1a9db7dd8496fbbc807f40307a6a3";
            this.applyFilter.Image = 2;
            this.applyFilter.ImageList = this.imlIcons;
            this.applyFilter.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.applyFilter.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.applyFilter.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            // 
            // adxRibbonMenu1
            // 
            this.adxRibbonMenu1.Caption = "adxRibbonMenu1";
            this.adxRibbonMenu1.Controls.Add(this.filterPavlovaRibbonButton);
            this.adxRibbonMenu1.Controls.Add(this.filterChaiRibbonButton);
            this.adxRibbonMenu1.Controls.Add(this.filterTofuRibbonButton);
            this.adxRibbonMenu1.Controls.Add(this.filterKonbuRibbonButton);
            this.adxRibbonMenu1.Id = "adxRibbonMenu_d706c28953644f81a8386aa51efde7aa";
            this.adxRibbonMenu1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonMenu1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // filterPavlovaRibbonButton
            // 
            this.filterPavlovaRibbonButton.Caption = "Pavlova";
            this.filterPavlovaRibbonButton.Id = "adxRibbonButton_88fe4d93649648659c0283972dfbd54d";
            this.filterPavlovaRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.filterPavlovaRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.filterPavlovaRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.filterPavlovaRibbonButton_OnClick);
            // 
            // filterChaiRibbonButton
            // 
            this.filterChaiRibbonButton.Caption = "Chai";
            this.filterChaiRibbonButton.Id = "adxRibbonButton_e88697e22ce14999b854039104ba9923";
            this.filterChaiRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.filterChaiRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.filterChaiRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.filterChaiRibbonButton_OnClick);
            // 
            // filterTofuRibbonButton
            // 
            this.filterTofuRibbonButton.Caption = "Tofu";
            this.filterTofuRibbonButton.Id = "adxRibbonButton_1f400419ea214676b492c8ba04ce3e88";
            this.filterTofuRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.filterTofuRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.filterTofuRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.filterTofuRibbonButton_OnClick);
            // 
            // filterKonbuRibbonButton
            // 
            this.filterKonbuRibbonButton.Caption = "Konbu";
            this.filterKonbuRibbonButton.Id = "adxRibbonButton_213e2dd542db4416843322ab75fbbbd4";
            this.filterKonbuRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.filterKonbuRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.filterKonbuRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.filterKonbuRibbonButton_OnClick);
            // 
            // AddinModule
            // 
            this.AddinName = "ExcelCharts";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel;

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Excel._Application ExcelApp
        {
            get
            {
                return (HostApplication as Excel._Application);
            }
        }

        private void insertChartRibbonButton_OnClick(object sender, 
            IRibbonControl control, bool pressed)
        {
            Excel.Worksheet activeSheet = null;
            Excel.Range selectedRange = null;
            Excel.Shapes shapes = null;
            Excel.Chart chart = null;
            Excel.ChartTitle chartTitle = null;

            try
            {
                activeSheet = (Excel.Worksheet)ExcelApp.ActiveSheet;
                selectedRange = (Excel.Range)ExcelApp.Selection;
                shapes = activeSheet.Shapes;
                shapes.AddChart2(Style: 201, XlChartType: Excel.XlChartType.xlColumnClustered,
                    Left: Type.Missing, Top: Type.Missing, Width: Type.Missing, 
                    Height: Type.Missing, NewLayout: true).Select();

                chart = ExcelApp.ActiveChart;
                chart.SetSourceData(selectedRange);
                chartTitle = chart.ChartTitle;
                chartTitle.Text = "Product Sales by Month";
            }
            finally
            {
                if (chartTitle != null) Marshal.ReleaseComObject(chartTitle);
                if (chart != null) Marshal.ReleaseComObject(chart);
                if (shapes != null) Marshal.ReleaseComObject(shapes);
                if (selectedRange != null) Marshal.ReleaseComObject(selectedRange);
            }
        }

        private void changeStyleRibbonButton_OnClick(object sender, 
            IRibbonControl control, bool pressed)
        {
            Excel.Chart chart = null;
            ADXRibbonItem selectedItem = null;

            try
            {
                chart = ExcelApp.ActiveChart;
                selectedItem = (ADXRibbonItem)styleNumberRibbonDropDown1.Items[
                    styleNumberRibbonDropDown1.SelectedItemIndex];
                chart.ChartStyle = selectedItem.Caption;
            }
            finally
            {
                if (chart != null) Marshal.ReleaseComObject(chart);
            }
        }

        private void changeChartColorRibbonButton_OnClick(object sender, 
            IRibbonControl control, bool pressed)
        {
            Excel.Chart chart = null;
            ADXRibbonItem selectedItem = null;

            try
            {
                chart = ExcelApp.ActiveChart;
                selectedItem = (ADXRibbonItem)colorNumberRibbonDropDown.Items[
                    colorNumberRibbonDropDown.SelectedItemIndex];
                chart.ChartColor = selectedItem.Caption;
            }
            finally
            {
                if (chart != null) Marshal.ReleaseComObject(chart);
            }
        }

        private void changeChartTypeRibbonButton_OnClick(object sender, 
            IRibbonControl control, bool pressed)
        {
            Excel.Chart chart = null;
            ADXRibbonItem selectedItem = null;

            try
            {
                chart = ExcelApp.ActiveChart;
                selectedItem = (ADXRibbonItem)chartTypeRibbonDropDown.Items[
                    chartTypeRibbonDropDown.SelectedItemIndex];
                chart.ChartType = (Excel.XlChartType)selectedItem.Tag;
            }
            finally
            {
                if (chart != null) Marshal.ReleaseComObject(chart);
            }
        }

        private void FilterChart(string productName)
        {
            Excel.Chart chart = null;
            Excel.ChartGroups chartGroups = null;
            Excel.ChartGroup chartGroup = null;
            Excel.ChartCategory chartCategory = null;
            Excel.CategoryCollection categoryCollection = null;

            try
            {
                chart = ExcelApp.ActiveChart;
                chartGroups = chart.ChartGroups() as Excel.ChartGroups;
                chartGroup = chartGroups.Item(1);
                categoryCollection = chartGroup.FullCategoryCollection() as 
                    Excel.CategoryCollection;
                for (int i = 1; i <= categoryCollection.Count; i++)
                {
                    chartCategory = categoryCollection.Item(i);
                    if (chartCategory.Name != productName)
                    {
                        chartCategory.IsFiltered = true;
                    }
                    if (chartCategory != null) Marshal.ReleaseComObject(chartCategory);
                }
            }
            finally
            {
                if (categoryCollection != null) Marshal.ReleaseComObject(categoryCollection);
                if (chartGroup != null) Marshal.ReleaseComObject(chartGroup);
                if (chartGroups != null) Marshal.ReleaseComObject(chartGroups);
                if (chart != null) Marshal.ReleaseComObject(chart);
            }
        }

        private void filterPavlovaRibbonButton_OnClick(object sender, 
            IRibbonControl control, bool pressed)
        {
            FilterChart("Pavlova");
        }

        private void filterChaiRibbonButton_OnClick(object sender, 
            IRibbonControl control, bool pressed)
        {
            FilterChart("Chai");
        }

        private void filterTofuRibbonButton_OnClick(object sender, 
            IRibbonControl control, bool pressed)
        {
            FilterChart("Tofu");
        }

        private void filterKonbuRibbonButton_OnClick(object sender, 
            IRibbonControl control, bool pressed)
        {
            FilterChart("Konbu");
        }

    }
}
